package Msm::Replace;

use strict;
use Msm::CellPhone;

sub new{
	my $self=shift;
	my $cgi = shift;
	my $config = shift;
	my $io = shift;
	my $data = shift;
	my $base = shift;
	my $hash = {};
	bless $hash,$self;
	$hash->{CGI} = $cgi;
	$hash->{BASE} = $base;
	$hash->{CellPhone} = new Msm::CellPhone();
	$hash->{DATA} = $data;
	$hash->{Err} = ();
	$hash->{Config}= $config;
	$hash->{IO}= $io;
	$hash->{AuthFileFlg}= 0;
	$hash->{DeepCnt} = 0;
	$hash->{DeepChangeCnt} = 0;
	$hash->{IfCnt} = 0;

	my %cook  = $hash->{CGI}->cookie(-name=>'MySketch');
	foreach(keys %cook){
		$hash->{Cookie}->{$_}=$cook{$_};
	}

	$ENV{'TZ'} = "JST-9";

	return $hash;
}

sub getCGI{
	my $self=shift;
	return $self->{CGI};
}

sub getIO{
	my $self=shift;
	return $self->{IO};
}

sub getConfig{
	my $self=shift;
	return $self->{Config};
}

sub getConfigData{
	my $self=shift;
	my $plug = shift;
	my $name = shift;
	return $self->getConfig->getConfigData($plug,$name);
}

#u 
#[u邼[[
sub changer{
	my $self=shift;
	my $html=shift;


	$html = $self->_changer($html,$self->{DATA});


	return $html;
}

sub createHTML{
	my $self=shift;
	my $html=shift;
	my $name=shift;
	my $create = shift;

	#print $html;
	$create = $self->changer($create);
	$name = $self->changer($name);

	$html=~s/\[%\s*CREATEHTML\s*%\]/$create/;
	$html = $self->changer($html);

	$self->getIO->createDir($self->getConfigData("","staticindexdir")."iframe/$name.html");
	$self->getIO->writeFile($self->getConfigData("","staticindexdir")."iframe/$name.html",$html);

	return $create;
}

sub _changer{
	my $self=shift;
	my $html=shift;
	my $hash=shift;

	my $dir = $self->{BASE}->getData("ShowDiary","dir");
	$dir =~ s/\//_/g;

	$self->{DeepCnt}++;
	#[vh~
	if($self->{DeepCnt} > 100){
		die "change loop err";
	}

	#IF
	$html = $self->ifcheck(undef,$html,[]);

	#ev[gJeSʂ̃ev[g̓ǂݍ݂B
	$html=~s/\[%\s*sub\s+load_ca_template\s*\(([^\.]*?)\)\s*%\]/$self->_changer($self->{BASE}->load_template($dir . '_' . $1),$self->{DATA})/ego;

	#ev[gJeSʂ̃ev[g̓ǂݍ݂B
	$html=~s/\[%\s*sub\s+load_ca_template2\s*\(([^\.]*?)\)\s*%\]/$self->_changer($self->{BASE}->load_template($1 . $dir),$self->{DATA})/ego;

	#ev[gev[g̓ǂݍ݂B
	$html=~s/\[%\s*sub\s+load_template\s*\(([^\.]*?)\)\s*%\]/$self->_changer($self->{BASE}->load_template($1),$self->{DATA})/ego;

	#createTemplate
	$html=~s/\[%\s*sub\s+createHTML\s*\(([^\.]*?),([^\.]*?)\)\s*\{\s*%\](.*?)\[%\s*\}\s*%\]/$self->createHTML($self->{BASE}->load_template($1),$2,$3)/sego;	

	#u
	$html=~s/\[%\s*(Config|ENV|Cookie|CGI|ESCAPE)\.(.+?)\s*%\]/$self->solochange($1,$2)/ego;

	#ʏu
	$html=~s/\[%\s*((?:(?!(?:ENV\.|CGI\.|Config\.|Cookie\.|ESCAPE\.|}|sub\s+)).)*?)\s*(\(.*?\)|)\s*%\]/$self->change($hash,$1,$2)/ego;

	$self->{DeepCnt}--;

	return $html;
}


#IF
sub ifcheck{
	my $self = shift;
	my $khtml = shift;
	my $html = shift;
	my $bool = shift;
	$self->{IfCnt}++;
	if($self->{IfCnt} > 20){
		die "if loop err";
	}

	if($html=~/(?:\[%\s*(IF)\s+([^\s]+?)(?:\s+(eq|==|ne|\!=|\<|\>|\<=|\>=)|)(?:\s+("[^"]*?"|\d+)|)\s*%\]|\[%\s*(ELSE)\s*%\]|\[%\s*(ENDIF)\s*%\])/o){
		if(defined($1) && $1 eq "IF"){

			if(@{$bool} > 0 && $bool->[0] == 0){
				push @{$bool},0;
				$khtml .= $`;
				$khtml = $self->ifcheck($khtml,$',$bool);
			}else{
				my $cdata = undef;
				my $name = $2;
				my $kei = $3;
				my $val = $4;
				my $ba = $';
				$khtml .= $`;

				$val =~s/"//g if(defined($val));

				if($name=~/^(ENV|CGI|Config|Cookie|ESCAPE)\.(.+)$/o){
					$cdata = $self->solochange($1,$2);
				}elsif($name=~/^(check_template|check_ca_template|check_ca_template2)\((.+)\)$/o){
					$cdata = $self->check_template($1,$2);
				}else{
					#̕ϐĂ邩`FbNH
					my $data = $self->{DATA};

					while($name=~/^(.*?)\.(.*)$/){
						$data = $data->{$1};
						$name = $2;
					}

					$cdata = $data->{$name};
				}
				if(!defined($cdata)){$cdata = "";}
				#$self->getIO->writeFileAdd("c.txt","$name,$kei,$val,$cdata\n");
				if(
					(
						defined($kei) &&
						(
							($kei eq "eq" && $val eq "$cdata")
							or
							($kei eq "ne" && $val ne "$cdata")
							or
							($kei eq "==" && $cdata ne '' && $val == $cdata)
							or
							($kei eq "!=" && $cdata ne '' && $val != $cdata)
							or
							($kei eq ">" && $cdata ne '' && $val < $cdata)
							or
							($kei eq "<" && $cdata ne '' && $val > $cdata)
							or
							($kei eq ">=" && $cdata ne '' && $val <= $cdata)
							or
							($kei eq "<=" && $cdata ne '' && $val >= $cdata)
						)
					)
					or
					(
						!defined($kei) && (
							(ref($cdata) eq 'ARRAY' && @{$cdata} > 0)
							or
							(ref($cdata) eq '' && ($cdata))
						)
					)
				){
					push @{$bool},1;
					$khtml = $self->ifcheck($khtml,$ba,$bool);
				}else{
					#$self->getIO->writeFileAdd("c.txt",ref($data->{$name})."=".$data->{$name}."$name"."\n");
					push @{$bool},0;
					$khtml = $self->ifcheck($khtml,$ba,$bool);
				}
			}
		}elsif(defined($5) && $5 eq "ELSE"){
			if(pop @{$bool} == 1){
				$khtml.=$`;
				unshift @{$bool},0;
			}else{
				unshift @{$bool},1;
			}
			$khtml = $self->ifcheck($khtml,$',$bool);
		}elsif(defined($6) && $6 eq "ENDIF"){
			if(pop @{$bool} == 1){
				$khtml.=$`;
			}

			$khtml = $self->ifcheck($khtml,$',$bool);
		}
	}else{
		$khtml.=$html;
	}
	$self->{IfCnt}--;
	return $khtml;
}

sub solochange{
	my $self=shift;
	my $head = shift;
	my $text=shift;
	if(!defined($head) || !defined($text)){
		return "";
	}

	if($head eq "ENV"){
		if($text eq "SCRIPT_NAME" && ($self->getConfigData("","script"))){
			return $self->getConfigData("","script");
		}
		return defined($ENV{$text}) ? $ENV{$text} : "";
	}elsif($head eq "Cookie"){
		return $self->{BASE}->getCookieValue($text);
	}elsif($head eq "CGI"){
		return $self->getCGI->param($text);
	}elsif($head eq "ESCAPE"){
		return "[%$text%]";
	}elsif($head eq "Config"){
		my $tmp = $text;
		if($tmp =~/^(.+?)\.(.+)$/o){
			return $self->getConfig->getConfigData($1,$2);
		}
	}
	return "";
}

#ʏȕ
sub change{
	my $self=shift;
	my $hash=shift;
	my $text=shift;
	my $temp=shift;


	if($text=~/^(.+?)\.(.+)$/o){
		$self->change($hash->{$1},$2,$temp);
	}else{
		#array͓B
		if(defined($hash->{$text}) && ref($hash->{$text}) eq 'ARRAY'){
			my @copy= @{$hash->{$text}};
			my $html="";
			$temp =~ s/\((.*)\)/$1/;
			my @temp = split(/,/,$temp);
			my $temphtml = $self->{BASE}->load_template($temp[0]);

			foreach my $vv(@copy){
				#push @copy,$vv;
				if($temp[1]){
					my $basyo = $self->{DATA};
					my $tuika = $temp[1];
					my $tt = $temp[1];
					while($temp[1]=~/([^\.]+)\.(.+)/og){
						$basyo = $basyo->{$1};
						$temp[1] = $2;
						$tuika = $2;
					}
					$temp[1] = $tt;
					$basyo->{$tuika} = $vv;
					$html.=$self->_changer($temphtml,$self->{DATA});
				}else{
					$hash->{$text}=$vv;
					$html.=$self->_changer($temphtml,$self->{DATA});
				}


			}
			$hash->{$text} = \@copy;
			return $html;
		}else{
			return defined($hash->{$text}) ? $hash->{$text} : "";
		}
	}


}


#LA擾
sub get_ca{
	my $self=shift;
	return $self->{CellPhone}->get_ca();
}


#ev[g̃fBNg擾
sub getTempDataDir{
	my $self = shift;
	if($self->{BASE}->getConfig->{FILENAME} eq "Config"){
		return $self->{BASE}->getConfig->getConfigData("","tempdir");		
	}else{		
		return $self->{BASE}->getAdConfigData('userdatadir')."/".$self->getCGI->param('blogid')."/template";
	}
}


#ev[g̗LmF
sub check_template {
	my $self = shift;
	my $head = shift;
	my $text = shift;
	if (!defined($head)) {
		return "";
	}

	my $dir = $self->{BASE}->getData("ShowDiary","dir");
	$dir =~ s/\//_/g;

	if ($head eq "check_ca_template") {
		$text = $dir . '_' . $text;
	}
	elsif ($head eq "check_ca_template2") {
		$text .= $dir;
	}
	elsif ($head ne "check_template") {
		return "";
	}

	if (!defined($text)) {
		return "";
	}

	$text = $self->getTempDataDir() . '/' . $text;

	my $template = {
		'i'=>'.i.html',
		'PC'=>'.html'
		};

	my $ca = $self->get_ca();

	my @template = (
		$template->{$ca},
		$template->{i},
		$template->{PC}
		);

	foreach (@template) {
		if (-e "$text$_") {
			return "true";
			last;
		}
	}

	return "";
}

1;
