#!/usr/local/bin/perl

# Ԃ̎擾p
my $enable_HiRes = eval 'use Time::HiRes qw/gettimeofday tv_interval/; [gettimeofday];';

if ($enable_HiRes) { use Time::HiRes qw/gettimeofday tv_interval/; }
my $start = $enable_HiRes ? $enable_HiRes : times;

my ($speed, $speed2 ,$speed3, $speed4) = 0.000000;

use strict;
use Msm::CGI;
use CGI::Carp qw(fatalsToBrowser set_message);
use Msm::Config;
use Msm::MySql;
use Msm::CellPhone;
use Msm::Init;

#print "Content-type: text/html\n\n";

if($ENV{'MOD_PERL'}){
	my $sf = $ENV{SCRIPT_FILENAME};
	if($sf=~/^(.*)\/.*$/){
		chdir $1;
	}
}


my $cgi = new Msm::CGI();
eval{
	$cgi->charset('Shift_JIS');
};
$@ = undef;

$cgi->delete('blogid');

my $config = new Msm::Config('Config',{},{});
my $mysql = new Msm::MySql($config);


#
if($config->getConfigData('','init') == 0){
	my $init = new Msm::Init($config);
	my $html = $init->execute($cgi);

	print "Content-type: text/html\n\n";
	print $html;

	exists($ENV{'MOD_PERL'}) ? Apache::exit(0) : CORE::exit(0);
}


#ÓIHTMLI_CNg
if($config->getConfigData('','staticmode') eq '1'){
	my $t = $cgi->param('t');
	my $file = $cgi->param('ShowDiary_file');
	my $dir = $cgi->param('ShowDiary_dir');
	my $date = $cgi->param('ShowDiary_date');
	my $page = $cgi->param('ShowDiary_page');
	if($page!~/^[0-9]+$/ || $page == 0){
		$cgi->delete('ShowDiary_page');
	}


	my $url = '';
	my $ext = new Msm::CellPhone->getCaTemplateID();

	my @key = $cgi->param();


	if(($file) && $t eq 'sketch' && $#key == 1 && $config->getConfigData('','staticmode_sketch') eq '1'){
		$url.='category'.$file.$ext.'.html';
	}elsif($dir && $t eq 'category' && $#key == 1 && $config->getConfigData('','staticmode_category') eq '1'){
		$url.='category'.$dir.$ext.'.html';
	}elsif($date && ($t eq 'day' || $t eq 'month') && $#key == 1){
		if($date =~ /\d+\/\d+\/\d+/ && $config->getConfigData('','staticmode_day') eq '1'){
			$url.='date/'.$date.$ext.'.html';
		}elsif($date =~ /\d+\/\d+\/$/ && $config->getConfigData('','staticmode_month') eq '1'){
			$date =~ s/\/$//;
			$url.='date/'.$date.$ext.'.html';
		}
	}elsif(!($cgi->param()) && $config->getConfigData('','staticmode_index') eq '1'){
		$url.='index'.$ext.'.html';
	}

	if($url){
		if(-e $config->getConfigData('','staticindexdir').$url){
			$url = $config->getConfigData('','staticindexurl').$url;
			if($url !~ /^http/){
				unless ($ENV{'SERVER_NAME'} eq 'localhost_home_pc_server56') {
					$url = 'http://' . $ENV{HTTP_HOST} . $url;
				}
				else {
					$url = 'http://127.0.0.1' . $url;
				}
			}
			print "Location: $url\n\n";
			#ÓIHTMLI͂ɏ𔲂BŷI
			exists($ENV{'MOD_PERL'}) ? Apache::exit(0) : CORE::exit(0);
		}
	}
}


use Msm::MySketch;
require './Msm/msjcode.pl';
my $io = new Msm::IO($config->getConfigData('','fileperm'),$config->getConfigData('','dirperm'));
my $ms = new Msm::MySketch($cgi,$config,$io,$config,$mysql);

my $tmp='';
if(!$cgi->param('t')){ $cgi->param(-name=>'t',-value=>'index');}

my $start2 = $enable_HiRes ? [gettimeofday] : times;
$ms->plugin_init();
my $end2 = $enable_HiRes ? [gettimeofday] : times;
$speed2 = $enable_HiRes ? sprintf('%.6f',tv_interval($start2, $end2)) : sprintf('%.3f',$end2 - $start2);
#printf 'init time %.6f b<br>'."\n", $speed2;

#F؏
unless($ms->getAuth($cgi->param('t'))){
	$ms->setErr('F؎s');
}else{

#URLɃOCpIDpX[h܂܂Ă΁A܂܂ȂURLփ_CNgB
if ($cgi->param('adminuser') || $cgi->param('adminpass')) {
	my $ext = new Msm::CellPhone->getCaTemplateID();
	unless ($ENV{'SERVER_NAME'} eq 'localhost_home_pc_server56') {
		$ms->setHeader('Location: http://' . $ENV{HTTP_HOST} . $config->getConfigData('','script') . '?t=' . $cgi->param('t') . '&blogid=' . $cgi->param('blogid') . ($ext ? '&authid=' . $cgi->param('authid') : ''));
	}
	else {
		$ms->setHeader('Location: http://127.0.0.1' . $config->getConfigData('','script') . '?t=' . $cgi->param('t') . '&blogid=' . $cgi->param('blogid') . ($ext ? '&authid=' . $cgi->param('authid') : ''));
	}
	$ms->printHeader();
	exists($ENV{'MOD_PERL'}) ? Apache::exit(0) : CORE::exit(0);
}

my $start2 = $enable_HiRes ? [gettimeofday] : times;

	$ms->plugin_execute();

my $end2 = $enable_HiRes ? [gettimeofday] : times;
$speed3 = $enable_HiRes ? sprintf('%.6f',tv_interval($start2, $end2)) : sprintf('%.3f',$end2 - $start2);
#printf "execute time %.6f b<br>\n", $speed3;

	$tmp = $ms->load_template($cgi->param('t'),'');
	#print "a=$tmp";

$start2 = $enable_HiRes ? [gettimeofday] : times;

	$tmp = $ms->changer($tmp);

$end2 = $enable_HiRes ? [gettimeofday] : times;
$speed4 = $enable_HiRes ? sprintf('%.6f',tv_interval($start2, $end2)) : sprintf('%.3f',$end2 - $start2);
#printf "chage time %.6f b<br>\n", $speed4;

	$tmp = $ms->plugin_change($tmp);

	$tmp = $ms->foot($tmp);

}

#err
my $err = $ms->getErrHtml();
if($err){
	$config->setConfigData('default','err','',$err);
	$tmp = $ms->load_template('err');
	$tmp = $ms->changer($tmp);
}

$ms->printHeader();

$tmp =~ s/<\$\sTime.init\s\$>/$speed2/g;
$tmp =~ s/<\$\sTime.execute\s\$>/$speed3/g;
$tmp =~ s/<\$\sTime.change\s\$>/$speed4/g;

my $end = $enable_HiRes ? [gettimeofday] : times;
$speed = $enable_HiRes ? sprintf('%.6f',tv_interval($start, $end)) : sprintf('%.3f',$end - $start);
#printf "view time %.6f b<br>\n", $speed;
$tmp =~ s/<\$\sTime.view\s\$>/$speed/g;

print $tmp;

$mysql->disconnect;

exists($ENV{'MOD_PERL'}) ? Apache::exit(0) : CORE::exit(0);
